﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using NPOI.HSSF.UserModel;
using NPOI.HPSF;
using NPOI.POIFS.FileSystem;
using NPOI.SS.UserModel;
namespace DataBaseToExcel
{
    public partial class Form1 : Form
    {
        static HSSFWorkbook hssfworkbook;
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            BtnDataBaseToExcel.Text = ConfigurationManager.AppSettings["DataBaseName"] + "数据字典导出到excel";
        }

        private void OraDataBaseLoadBind()
        {

        }
        private void BtnWisco_Click(object sender, EventArgs e)
        {

            string sqlString = "select t.TABLE_NAME,c.comments from all_tables t,user_tab_comments c\n" +
"                    where t.TABLE_NAME=c.table_name and  t.owner ='SFTMONI'\n" +
"                    order by t.owner, t.table_name";
            DataTable dtGetTable = DbHelperOra.Query(sqlString).Tables[0];
            for (int idtGetTable = 0; idtGetTable < dtGetTable.Rows.Count; idtGetTable++)
            {
                InitializeWorkbook();    
                string sNa = hssfworkbook.GetSheetName(0);
                ISheet sheet1 = hssfworkbook.GetSheet(sNa);
                ICellStyle style = hssfworkbook.CreateCellStyle();
                style.BorderBottom = CellBorderType.THIN;
                style.BorderLeft = CellBorderType.THIN;
                style.BorderRight = CellBorderType.THIN;
                style.BorderTop = CellBorderType.THIN;
                string strTablesNames = dtGetTable.Rows[idtGetTable].ItemArray[0].ToString();              

                sheet1.GetRow(1).GetCell(8).SetCellValue(strTablesNames+dtGetTable.Rows[idtGetTable].ItemArray[1].ToString() ?? " ");
                #region 查询表的结构信息的语句
                string sqlString1 = "SELECT " +
                            "USER_TAB_COLS.COLUMN_ID    as 列序号,\n" +
                            "user_col_comments.comments as 备注,\n" +
                            "USER_TAB_COLS.COLUMN_NAME as 列名,\n" +
                            "USER_TAB_COLS.DATA_TYPE    as 数据类型,\n" +
                            "USER_TAB_COLS.DATA_LENGTH as 长度,\n" +
                            "USER_TAB_COLS.DATA_PRECISION as 整数位,\n" +
                            "User_Tab_Cols.DATA_SCALE     as 小数位,\n" +
                            "USER_TAB_COLS.NULLABLE     as 是否为空\n" +
                            "FROM USER_TAB_COLS\n" +
                            "inner join user_col_comments on user_col_comments.TABLE_NAME =\n" +
                            "USER_TAB_COLS.TABLE_NAME\n" +
                            "and user_col_comments.COLUMN_NAME = USER_TAB_COLS.COLUMN_NAME\n" +
                            "and USER_TAB_COLS.TABLE_NAME='" + strTablesNames + "' order by  USER_TAB_COLS.COLUMN_ID";
                DataTable dtGetRowTable = DbHelperOra.Query(sqlString1).Tables[0];
                #endregion
                int DataRowCount = dtGetRowTable.Rows.Count;
                int rowIndex = 5;//表示从第几行开始构造内容
                #region 针对日期类型特殊处理列格式
                HSSFCellStyle dateStyle = hssfworkbook.CreateCellStyle() as HSSFCellStyle;
                dateStyle.BorderBottom = CellBorderType.THIN;
                dateStyle.BorderLeft = CellBorderType.THIN;
                dateStyle.BorderRight = CellBorderType.THIN;
                dateStyle.BorderTop = CellBorderType.THIN;
                HSSFDataFormat format = hssfworkbook.CreateDataFormat() as HSSFDataFormat;
                dateStyle.DataFormat = format.GetFormat("yyyy-mm-dd");
                #endregion
                #region 构造表的字段结构信息内容
                rowIndex = CreateDataMethod(sheet1, style, dtGetRowTable, rowIndex, dateStyle);


                #endregion
                #region 创建表尾表头
                IRow cFootRow = sheet1.CreateRow(DataRowCount + 6);
                ICell cFootCell = cFootRow.CreateCell(0, CellType.STRING);
                cFootCell.SetCellValue("索引名");
                cFootCell.CellStyle = style;

                cFootCell = cFootRow.CreateCell(1, CellType.STRING);
                cFootCell.SetCellValue("字段名");
                cFootCell.CellStyle = style;

                cFootCell = cFootRow.CreateCell(2, CellType.STRING);
                cFootCell.SetCellValue("顺序");
                cFootCell.CellStyle = style;

                cFootCell = cFootRow.CreateCell(3, CellType.STRING);
                cFootCell.SetCellValue("是否唯一");
                cFootCell.CellStyle = style;
                for (int iNum = 4; iNum < 10; iNum++)
                {
                    cFootCell = cFootRow.CreateCell(iNum);
                    cFootCell.SetCellValue("");
                    cFootCell.CellStyle = style;
                }

                #region 查询索引数据并且写入
                int iRowindex = DataRowCount + 7;
                DataTable dt = new DataTable();
                StringBuilder sb = new StringBuilder("select c.名称,c.字段,rownum,c.是否唯一 from (select t.INDEX_NAME as 名称,wmsys.wm_concat(t.COLUMN_NAME) as 字段,wmsys.wm_concat(i.uniqueness) as 是否唯一 " +
                "  from user_ind_columns t, user_indexes i " +
                " where t.index_name = i.index_name " +
                "   and t.table_name = '" + strTablesNames +
                "' group by t.INDEX_NAME) c");
                dt = DbHelperOra.Query(sb.ToString()).Tables[0];
                CreateDataMethod(sheet1, style, dt, iRowindex, dateStyle);
                #endregion
                #endregion

                WriteToFile(strTablesNames + ".xls");
            }

        }

        #region 单元格数据生成通用类
        private static int CreateDataMethod(ISheet sheet1, ICellStyle style, DataTable dtGetRowTable, int rowIndex, HSSFCellStyle dateStyle)
        {
            foreach (DataRow row in dtGetRowTable.Rows)
            {
                #region 填充内容
                HSSFRow dataRow = sheet1.CreateRow(rowIndex) as HSSFRow;
                foreach (DataColumn column in dtGetRowTable.Columns)
                {
                    HSSFCell newCell = dataRow.CreateCell(column.Ordinal) as HSSFCell;
                    string drValue = row[column].ToString();
                    #region 字段类型处理
                    switch (column.DataType.ToString())
                    {
                        case "System.String": //字符串类型
                            newCell.SetCellValue(drValue);
                            newCell.CellStyle = style;
                            break;
                        case "System.DateTime": //日期类型
                            DateTime dateV;
                            DateTime.TryParse(drValue, out dateV);
                            newCell.SetCellValue(dateV);
                            newCell.CellStyle = dateStyle; //格式化显示
                            break;
                        case "System.Boolean": //布尔型
                            bool boolV = false;
                            bool.TryParse(drValue, out boolV);
                            newCell.SetCellValue(boolV);
                            newCell.CellStyle = style;
                            break;
                        case "System.Int16": //整型
                        case "System.Int32":
                        case "System.Int64":
                        case "System.Byte":
                            int intV = 0;
                            int.TryParse(drValue, out intV);
                            newCell.SetCellValue(intV);
                            newCell.CellStyle = style;
                            break;
                        case "System.Decimal": //浮点型
                        case "System.Double":
                            double doubV = 0;
                            double.TryParse(drValue, out doubV);
                            newCell.SetCellValue(doubV);
                            newCell.CellStyle = style;
                            break;
                        case "System.DBNull": //空值处理
                            newCell.SetCellValue("");
                            newCell.CellStyle = style;
                            break;
                        default:
                            newCell.SetCellValue(drValue);
                            newCell.CellStyle = style;
                            break;
                    }
                    #endregion
                    #region 插入留余空白列
                    int iLastCell = sheet1.GetRow(4).LastCellNum + 1 - dtGetRowTable.Columns.Count;
                    for (int i = 1; i < iLastCell; i++)
                    {
                        HSSFCell newNullCell = dataRow.CreateCell(newCell.ColumnIndex + i) as HSSFCell;
                        newNullCell.SetCellValue("");
                        newNullCell.CellStyle = style;
                    }
                    #endregion

                }

                #endregion
                rowIndex++;
            }
            return rowIndex;
        } 
        #endregion





        static void WriteToFile(string xlsNames)
        {
            FileStream file = new FileStream(xlsNames, FileMode.Create);
            hssfworkbook.Write(file);
            file.Close();
        }

        static void InitializeWorkbook()
        {
            FileStream file = new FileStream(@"template/WiscoDataBaseToExcelTemplate.xls", FileMode.Open, FileAccess.Read);

            hssfworkbook = new HSSFWorkbook(file);

            DocumentSummaryInformation dsi = PropertySetFactory.CreateDocumentSummaryInformation();
            dsi.Company = "君正科技";
            hssfworkbook.DocumentSummaryInformation = dsi;

            SummaryInformation si = PropertySetFactory.CreateSummaryInformation();
            si.Subject = "武钢二冷轧成品库";
            hssfworkbook.SummaryInformation = si;
        }

        private void BtnDataBaseToExcel_Click(object sender, EventArgs e)
        {
            string DatabaseOwner = ConfigurationManager.AppSettings["DataBaseName"];
            string sqlString="select t.* from all_tables t " +
                    "where t.owner ='" + DatabaseOwner + "' order by t.owner, t.table_name";
            DataTable dtTablename=DbHelperOra.Query(sqlString).Tables[0];
            for (int i=0;i<dtTablename.Rows.Count;i++)
            {
                string sqlString1 = "SELECT " +
                        "USER_TAB_COLS.COLUMN_ID    as 列序号,\n" +
                        "user_col_comments.comments as 备注,\n" +
                        "USER_TAB_COLS.COLUMN_NAME as 列名,\n" +
                        "USER_TAB_COLS.DATA_TYPE    as 数据类型,\n" +
                        "USER_TAB_COLS.DATA_LENGTH as 长度,\n" +
                        "USER_TAB_COLS.DATA_PRECISION as 整数位,\n" +
                        "User_Tab_Cols.DATA_SCALE     as 小数位,\n" +
                        "USER_TAB_COLS.NULLABLE     as 是否为空\n" +
                        "FROM USER_TAB_COLS\n" +
                        "inner join user_col_comments on user_col_comments.TABLE_NAME =\n" +
                        "USER_TAB_COLS.TABLE_NAME\n" +
                        "and user_col_comments.COLUMN_NAME = USER_TAB_COLS.COLUMN_NAME\n" +
                        "and USER_TAB_COLS.TABLE_NAME='" + dtTablename.Rows[i][1].ToString()+ "' order by  USER_TAB_COLS.COLUMN_ID";
                DataTable dt=DbHelperOra.Query(sqlString1).Tables[0];
                ExcelHelper.ExportDTtoExcel(dt, dtTablename.Rows[i][1].ToString(), dtTablename.Rows[i][1].ToString()+".xls");
            }
        }

        private void BtnRead_Click(object sender, EventArgs e)
        {

        }


    }
}
